<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVehicleTachoReadoutIdentifier ArrayType
 * @subpackage Arrays
 */
class ArrayOfVehicleTachoReadoutIdentifier extends AbstractStructArrayBase
{
    /**
     * The VehicleTachoReadoutIdentifier
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\VehicleTachoReadoutIdentifier[]
     */
    public $VehicleTachoReadoutIdentifier;
    /**
     * Constructor method for ArrayOfVehicleTachoReadoutIdentifier
     * @uses ArrayOfVehicleTachoReadoutIdentifier::setVehicleTachoReadoutIdentifier()
     * @param \StructType\VehicleTachoReadoutIdentifier[] $vehicleTachoReadoutIdentifier
     */
    public function __construct(array $vehicleTachoReadoutIdentifier = array())
    {
        $this
            ->setVehicleTachoReadoutIdentifier($vehicleTachoReadoutIdentifier);
    }
    /**
     * Get VehicleTachoReadoutIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\VehicleTachoReadoutIdentifier[]|null
     */
    public function getVehicleTachoReadoutIdentifier()
    {
        return isset($this->VehicleTachoReadoutIdentifier) ? $this->VehicleTachoReadoutIdentifier : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVehicleTachoReadoutIdentifier method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVehicleTachoReadoutIdentifier method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVehicleTachoReadoutIdentifierForArrayConstraintsFromSetVehicleTachoReadoutIdentifier(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem) {
            // validation for constraint: itemType
            if (!$arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem instanceof \StructType\VehicleTachoReadoutIdentifier) {
                $invalidValues[] = is_object($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem) ? get_class($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem) : sprintf('%s(%s)', gettype($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem), var_export($arrayOfVehicleTachoReadoutIdentifierVehicleTachoReadoutIdentifierItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VehicleTachoReadoutIdentifier property can only contain items of type \StructType\VehicleTachoReadoutIdentifier, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VehicleTachoReadoutIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleTachoReadoutIdentifier[] $vehicleTachoReadoutIdentifier
     * @return \ArrayType\ArrayOfVehicleTachoReadoutIdentifier
     */
    public function setVehicleTachoReadoutIdentifier(array $vehicleTachoReadoutIdentifier = array())
    {
        // validation for constraint: array
        if ('' !== ($vehicleTachoReadoutIdentifierArrayErrorMessage = self::validateVehicleTachoReadoutIdentifierForArrayConstraintsFromSetVehicleTachoReadoutIdentifier($vehicleTachoReadoutIdentifier))) {
            throw new \InvalidArgumentException($vehicleTachoReadoutIdentifierArrayErrorMessage, __LINE__);
        }
        if (is_null($vehicleTachoReadoutIdentifier) || (is_array($vehicleTachoReadoutIdentifier) && empty($vehicleTachoReadoutIdentifier))) {
            unset($this->VehicleTachoReadoutIdentifier);
        } else {
            $this->VehicleTachoReadoutIdentifier = $vehicleTachoReadoutIdentifier;
        }
        return $this;
    }
    /**
     * Add item to VehicleTachoReadoutIdentifier value
     * @throws \InvalidArgumentException
     * @param \StructType\VehicleTachoReadoutIdentifier $item
     * @return \ArrayType\ArrayOfVehicleTachoReadoutIdentifier
     */
    public function addToVehicleTachoReadoutIdentifier(\StructType\VehicleTachoReadoutIdentifier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VehicleTachoReadoutIdentifier) {
            throw new \InvalidArgumentException(sprintf('The VehicleTachoReadoutIdentifier property can only contain items of type \StructType\VehicleTachoReadoutIdentifier, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VehicleTachoReadoutIdentifier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\VehicleTachoReadoutIdentifier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VehicleTachoReadoutIdentifier
     */
    public function getAttributeName()
    {
        return 'VehicleTachoReadoutIdentifier';
    }
}
